//+------------------------------------------------------------------+
//|                                                TrendStrength mtf |
//|                                               original by Igorad |
//|                   mod by mrtools sorta using Mladen's techniques |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     Gold
#property indicator_style1     STYLE_DASH
#property indicator_color2     LimeGreen
#property indicator_width2     2 
#property indicator_color3     Red
#property indicator_width3     2 
#property indicator_level1     80
#property indicator_level2     50
#property indicator_level3     20
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string  TimeFrame       = "Current time frame";
extern int     RsxLength       = 14;
extern int     SmoothLength    = 1;
extern double  SmoothPhase     = 0;
extern bool    SmoothDouble    = true;
extern int     Price           = 0;
extern double  Kv              = 4.236; // Multiplier 
extern bool    Interpolate     = true;

extern string  _               = "alerts settings";
extern bool    alertsOn        = true;
extern bool    alertsOnCurrent = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = false;
extern bool    alertsEmail     = false;

extern bool    arrowsVisible   = false;
extern string  arrowsUniqueID  = "tsarrows";
extern color   arrowsUpColor   = DeepSkyBlue;
extern color   arrowsDnColor   = PaleVioletRed;
extern int     arrowsUpCode    = 221;
extern int     arrowsDownCode  = 222;
extern int     arrowsSize      = 1;

//
//
//
//
//

double rsx[];
double UpTrend[];
double DnTrend[];
double smin[];
double smax[];
double Delta[];
double trend[];
double tsj[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,rsx);     SetIndexLabel(0,"rsx");
   SetIndexBuffer(1,UpTrend); SetIndexLabel(1,"UpTrend");
   SetIndexBuffer(2,DnTrend); SetIndexLabel(2,"DnTrend"); 
   SetIndexBuffer(3,smin);
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,Delta);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,tsj);
   
   //
   //
   //
   //
   //
   
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   if (StringSubstr(Symbol(),3,3)=="JPY") { Kv=Kv/100;  }
   
   IndicatorShortName(timeFrameToString(timeFrame)+ "  trend strength ("+RsxLength+")");
 
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsUniqueID+":";
   int    lookForLength = StringLen(lookFor);
      for (int i=ObjectsTotal()-1; i>=0; i--)
      {
         string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
      }
   return(0);
}

//
//
//
//
//

double wrkBuffer[][13];

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,j,n,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
        limit=MathMin(Bars-counted_bars,Bars-1);
        if (returnBars) { rsx[0] = limit+1; return(0); }
        if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+RsxLength);
   double Hg =  1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

      if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double roc = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double roa = MathAbs(roc);
      
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (roa != 0)
           rsx[i] = iDSmooth(MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00),SmoothLength,SmoothPhase,SmoothDouble,i,0); 
      else rsx[i] = iDSmooth(50.0                                            ,SmoothLength,SmoothPhase,SmoothDouble,i,0); 
      
      //
      //
      //
      //
      //
      
      double hrsx = 0;
      double lrsx = 0;
      
      if (rsx[i] > rsx[i+1]) 
      {
      hrsx = rsx[i]; 
      lrsx = rsx[i+1];
      }
      else 
      
      if (rsx[i] < rsx[i+1]) 
      {
      hrsx = rsx[i+1]; 
      lrsx = rsx[i];
      }
      else
      {
      
      hrsx = rsx[i]; 
      lrsx = rsx[i];
      }
          
      Delta[i] = iDSmooth(iMA(hrsx - lrsx,0,2*RsxLength-1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,SmoothDouble,i,20);
      
      //
      //
      //
      //
      //
     
      smin[i]    = rsx[i] - Kv * Delta[i]; 
      smax[i]    = rsx[i] + Kv * Delta[i];
      DnTrend[i] = EMPTY_VALUE;
      UpTrend[i] = EMPTY_VALUE;
      tsj[i]     = tsj[i+1];  
      trend[i]   = trend[i+1];
      
      //
      //
      //
      //
      //
      
      if (rsx[i] > smax[i+1]) tsj[i]= 1; 
	   if (rsx[i] < smin[i+1]) tsj[i]=-1;
	   if (tsj[i] > 0)
	   {
	   if (smin[i] < smin[i+1]) smin[i] = smin[i+1]; UpTrend[i] = smin[i]; trend[i] =  1;  
	   } 
	   if (tsj[i] < 0)
	   {
	   if (smax[i] > smax[i+1]) smax[i] = smax[i+1]; DnTrend[i] = smax[i]; trend[i] =  -1; 
	   } 
	   
	   manageArrow(i); 
         
     }
     manageAlerts();
     return(0);
   }
	   
	   

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rsx[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxLength,SmoothLength,SmoothPhase,SmoothDouble,Price,Kv,0,y);
         UpTrend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxLength,SmoothLength,SmoothPhase,SmoothDouble,Price,Kv,1,y);
         DnTrend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxLength,SmoothLength,SmoothPhase,SmoothDouble,Price,Kv,2,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxLength,SmoothLength,SmoothPhase,SmoothDouble,Price,Kv,6,y);
         
         manageArrow(i);
         
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(j = 1; j < n; j++)
            {
                rsx[i+j]     = rsx[i]     + (rsx[i+n]     - rsx[i])     * j/n;
                if (UpTrend[i]!= EMPTY_VALUE && UpTrend[i+n]!= EMPTY_VALUE) UpTrend[i+j] = UpTrend[i] + (UpTrend[i+n] - UpTrend[i]) * j/n;
                if (DnTrend[i]!= EMPTY_VALUE && DnTrend[i+n]!= EMPTY_VALUE) DnTrend[i+j] = DnTrend[i] + (DnTrend[i+n] - DnTrend[i]) * j/n;
            }
            
   }
   
   manageAlerts();  
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" TrendStrength ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  TrendStrength "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]); 
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] ==  1) drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
         if (trend[i] == -1) drawArrow(i,arrowsDnColor,arrowsDownCode,true);
      }         
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsUniqueID+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsUniqueID+":"+time; ObjectDelete(lookFor);
}

